/* Installation und Update von SMS-GW.EXE                                   */
/* Programm geschrieben von U.Kunz  ulrich_kunz@ibm.net                     */
/* OS/2 Programm zum versenden von Kurznachrichten                          */
/* Hilfe mit     INSTALL.CMD -?  aufrufen                                   */
PARSE UPPER ARG Unterverzeichnis
PARSE SOURCE PROGRAMM
SOURCE_DRIVE=SUBSTR(PROGRAMM,POS(':',PROGRAMM)-1,LASTPOS('\',PROGRAMM)-POS(':',PROGRAMM)+1)  /* Ermitteln des Source Laufwerkes */
BOOT_DRIVE = FILESPEC('DRIVE',VALUE('SYSTEM_INI',,'OS2ENVIRONMENT'))
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
rc=syscls()
say ' '
rc=sysFileTree(SOURCE_DRIVE||'\SMS-GW.EXE','Datei',F)
If  Datei.0 = '0' Then Signal FehlerText2
Unterverzeichnis = SPACE(Unterverzeichnis)
Select
   When Unterverzeichnis = '' Then Signal FehlerText
   When Right(Unterverzeichnis,2)='-?' Then Signal FehlerText
   When Right(Unterverzeichnis,2)='-U' Then Signal Update
   When Right(Unterverzeichnis,2)='-I' Then Signal Install_Default
   When Right(Unterverzeichnis,2)='/?' Then Signal FehlerText
   When Right(Unterverzeichnis,2)='/U' Then Signal Update
   When Right(Unterverzeichnis,2)='/I' Then Signal Install_Default
   When LENGTH(Unterverzeichnis) < 4  Then Signal FehlerText
   When SUBSTR(Unterverzeichnis,2,1)=':' Then Signal Install
   Otherwise do
      say ' '
      say 'Fehler aufgetreten. Installation abgebrochen. Weitere Hilfe mit A:\Install -?'
      return
   end
end


Install:
say 'Die Installation hat begonnen'
rc=SysMkDir(Unterverzeichnis)
if rc=5 Then do
   say 'Unterverzeichnis ist schon vorhanden. Bitte lschen , ein Anderes angeben'
   say 'oder, falls das Programm schon vorhanden ist, mit Install -U arbeiten.'
   say 'Weitere Hilfe mit Install -?'
   RETURN
end
if rc = 0 then do
   CALL DATEI_COPY
   /* Erstellen des Programm-Objekts         */
   rc = SysCreateObject("WPProgram", "SMS-Gateway", "<WP_DESKTOP>",,
        "EXENAME="||Unterverzeichnis||"\SMS-GW.EXE;STARTUPDIR="||Unterverzeichnis)
   if rc = 1 then do
      say 'Die Installation wurde erfolgreich beendet.'
      say 'Bitte auf der Arbeitsoberflche die Icone SMS-Gateway anklicken.'
      say '------------------------------------------------------------------------- '
   end
   else say 'Auf der Arbeitsoberfche konnte nicht das Object erstellt werden.'
   RETURN
end
say 'Unterverzeichnis konnte nicht erstellt werden. Installation abgebrochen'
RETURN


Update:
say 'Der Update hat begonnen'
Schleife = 1
if LENGTH(Unterverzeichnis) > 2 then do
   if SUBSTR(Unterverzeichnis,2,1)=':' Then do
      DRIVE.1 = LEFT(Unterverzeichnis,2)
   end
   else do
      say "Es ist kein Laufwerk angegeben, wie z.B. Install  F:  -u"
      return
   end
end
else do
   rc = SysDriveMap('C','LOCAL')
   if Length(rc) = 2 then Drive.Schleife = rc
   Do While POS(' ',RC) <> 0
     Drive.Schleife = SUBSTR(rc,POS(' ',rc)-2,2)
     Schleife = Schleife+1
     rc = SUBSTR(rc,4)
     Drive.Schleife = rc
   end
end
Zahl=1
Do Schleife
   if SysDriveInfo(Drive.Zahl) <> '' then do
      rc = sysFiletree(Drive.Zahl||'\SMS-GW.EXE','Datei',FSO)
      If Datei.0 = '0' then do
         Zahl=Zahl+1
         ITERATE
      End  /* If then do */
      If Datei.0 = 1 Then do
         If TRANSLATE(Datei.1) = TRANSLATE(SOURCE_DRIVE||'\SMS-GW.EXE') Then LEAVE
         Pfad = Datei.Zahl
         SIGNAL Kopieren
      end  /* if then do */
      Weiter:
      if Datei.0 = 2 then do
         If TRANSLATE(Datei.1) = TRANSLATE(SOURCE_DRIVE||'\SMS-GW.EXE') Then Pfad = Datei.2
         else
         Pfad = Datei.1
         SIGNAL Kopieren
      end  /* if then do */
      else do
         say 'Mehr als eine Kopie des Programms gefunden. Bitte die 2. Kopie'
         say 'lschen. Hilfe bekommen Sie mit Install -?'
         RETURN
      end /* else do */
   end
end
say 'Das Programm nicht gefunden. Bitte suchen und Installation eventuell mit '
say 'X:\INSTALL X:\PFAD noch einmal starten'
RETURN

KOPIEREN:
Unterverzeichnis = SUBSTR(Pfad,1,LASTPOS('\',Pfad))
CALL DATEI_COPY
/* Erstellen des Programm-Objekts         */
rc = SysCreateObject("WPProgram", "SMS-Gateway", "<WP_DESKTOP>",,
     "EXENAME="||Pfad||";STARTUPDIR="||SUBSTR(Pfad,1,LASTPOS('\',Pfad)),'Update')
say 'Der Update wurde erfolgreich beendet.'
say '------------------------------------- '

RETURN


Install_Default:
rc=SysCLS()
say
say 'Die Installation hat begonnen'
Unterverzeichnis=BOOT_DRIVE||'\SMS-GW'
rc=SysMkDir(Unterverzeichnis)
if rc=5 Then do
   say 'Unterverzeichnis ist schon vorhanden. Bitte lschen , ein Anderes angeben'
   say 'oder falls das Programm schon vorhanden ist mit Install -U arbeiten'
   say 'weitere Hilfe mit Install -?'
   RETURN
end
if rc = 0 then do
    CALL DATEI_COPY
   /* Erstellen des Programm-Objekts         */
   rc = SysCreateObject("WPProgram", "SMS-Gateway", "<WP_DESKTOP>",,
        "EXENAME="||Unterverzeichnis||"\SMS-GW.EXE;STARTUPDIR="||Unterverzeichnis)
   if rc = 1 then do
      say 'Die Installation wurde erfolgreich beendet.'
      say 'Bitte auf der Arbeitsoberflche die Icone SMS-Gateway anklicken.'
      say '------------------------------------------------------------------------- '
   end
   else say 'Auf der Arbeitsoberfche konnte nicht das Object erstellt werden.'
   RETURN
end
say 'Unterverzeichnis konnte nicht erstellt werden. Installation abgebrochen'
RETURN
FehlerText:
say'Bitte folgendes Format einhalten: '
say'                                  '
say' A:\INSTALL  -I             Fr default Installation  auf die'
say'                            Boot-Drive in das Unterverzeichnis  \SMS-GW'
say'                                                              '
say' A:\INSTALL  D:\MeinProg    Das Programm wird in das Unterverzeichnis \MeinProg'
say'                            auf Platte D: gespielt.'
say'                            Das Laufwerk mu mit angegeben werden. \MeinProg'
say'                            reicht nicht aus'
say'                                                   '
say' A:\INSTALL  [DRIVE:] -U    Sie haben das Programm schon auf Ihrem Rechner'
say'                            und mchten eine neue Version aufspielen.'
say'                            Achtung ! geben Sie keine Drive an, so werden nur'
say'                            lokale Platten durchsucht.'
say'                            Die vorhandenen Einstellungen werden nicht gendert'
say'                                                                    '
say' A:\Install  -?             Diese Hilfe ...'
say' '
say' Fr Experten : Bei einem Update knnen die neuen Dateien einfach in das schon'
say' vorhandene Unterverzeichnis kopiert werden. Die persnlichen Einstellungen'
say' befinden sich in der SMS-GW.INI, die im Update nicht enthalten ist.'
RETURN

DATEI_COPY:

'COPY '||SOURCE_DRIVE||'\SMS-GW.EXE 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\SMS-GW.HLP 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\READ.ME 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\MODEM.LST 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\RXCOM.DLL 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\COMPORT.DLL 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\REGISTER.TXT 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\SMS.INF 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\REG_MAIL.TXT 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\INSTALL.CMD 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\VpUtil.DLL 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\FEHLER.CMD 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\PROBLEM.CMD 'Unterverzeichnis
'COPY '||SOURCE_DRIVE||'\Beispiel.sms 'Unterverzeichnis
RETURN

FehlerText2:
say' Das ZIP Archiv ist nicht vollstndig, oder es wurden vorher'
say' Dateien gelscht.'
RETURN
